/*

            LIBRERIA PER DISPLAY TFT DA 2,4 INC
            ILI9341

*/
// TFT module connections
 char TFT_DataPort at PORTC;               // Data 8 bit
 char TFT_DataPort_Direction at TRISC;
//
 sbit TFT_RST at LATD0_bit;              // Reset
 sbit TFT_CS at LATD3_bit;                // CS
 sbit TFT_RS at LATA0_bit;               // RS
 sbit TFT_RD at LATD1_bit;               // RD
 sbit TFT_WR at LATA1_bit;               // WR
//
 sbit TFT_RST_Direction at TRISD0_bit;
 sbit TFT_CS_Direction at TRISD3_bit;
 sbit TFT_RS_Direction at TRISA0_bit;
 sbit TFT_RD_Direction at TRISD1_bit;
 sbit TFT_WR_Direction at TRISA1_bit;
// End TFT module connections
// *****************************************************************************
//
// *****************************************************************************
#define BLACK   0x0000
#define BLUE    0x001F
#define RED     0xF800
#define GREEN   0x07E0
#define CYAN    0x07FF
#define MAGENTA 0xF81F
#define YELLOW  0xFFE0
#define WHITE   0xFFFF
#define Azzurro 0x0C0C

// Touchscreen connection (need two analog inputs):
#define Y1 TFT_WR     //   RD3   (TFT_WR)
#define X1 TFT_RS     //   RD1   (TFT_RS)
#define Y2 PORTC.B7   //   RC7   (PORTC.B7)
#define X2 PORTC.B6   //   RC6   (PORTC.B6)
//
 unsigned int X = 320;
 unsigned int Y = 240;
 unsigned int col_x, row_y;
 unsigned int col, row;
 unsigned int cnt_16;
 char sw_value = 0;

 const char time_1 = 40;
//
 unsigned int P_COL=0; // LCD cursor pointer
 unsigned int P_ROW=0;
 unsigned int T_COL=0; // TOUCHSCREEN(TS) detected value
 unsigned int T_ROW=0;
// --- Il valore dei touch ai bordi dello schermo, dipendono dal valore del'alimentazione,
//     dalla resistenza pool-up, dal tipo del touch, ecc. I valori vanno testati con la
//     calibrazione.
// TS calibration
 unsigned int ROW_F=99; // TS first row
 unsigned int ROW_L=641; // TS last row
 unsigned int COL_F=84; // TS first column
 unsigned int COL_L=680; // TS last column

 unsigned int row_0; // TS first row
 unsigned int row_240; // TS last row
 unsigned int col_0; // TS first column
 unsigned int col_320; // TS last column
//
 unsigned short F_SIZE=3; // font size
 unsigned int F_COLOR = WHITE; // foreground color
 unsigned int B_COLOR = 0x0C0C; // background color  (Azzurro)
 unsigned int D_COL, D_ROW;
// draw keypad
//const short K_LABEL[] = {"1","2","3","4","5","6","7","8","9","0","<"};    //String
 const char K_LABEL[] = "7894561230<";
 const unsigned int K_ROW[]  = {125,125,125,65,65,65,5,5,5,185,185};
 const unsigned int K_COL[]  = {10,70,130,10,70,130,10,70,130,70,130};
 const char *txt_1  = "Premi alto a Sx";
 const char *txt_2  = "Premi alto a Dx";
 const char *txt_3  = "Premi basso a Sx";
// ---
  void Delay_msec (unsigned int count_delay);
  void BD_as_input(void);
  void BD_as_output(void);
  void Display_char(char znak);
  void page_1 (void);
//


// *****************************************************************************
// Scrivi il dato o comando
// *****************************************************************************
 void LCD_write(unsigned short d) {
// ILI9341 reads data pins when WR rises from LOW to HIGH
   TFT_WR = 0;
    TFT_DataPort = d;
     TFT_WR = 1;
 }
// *****************************************************************************
// Scrivi comando
// *****************************************************************************
 void LCD_command_write(unsigned short d) {
//
   TFT_RS =0;
    LCD_write(d);
 }
// *****************************************************************************
// Scrivi dato
// *****************************************************************************
 void LCD_data_write(unsigned short d) {
//
   TFT_RS = 1;
    LCD_write(d);
 }
// *****************************************************************************
// Leggi il dato sulla porta
// *****************************************************************************
 unsigned short LCD_read(void) {
  char port_TFT;
// CS LOW, WR HIGH, RD HIGH->LOW>HIGH, RS(D/C) HIGH
    TFT_RS = 1;
// After RD falls from HIGH to LOW ILI9341 outputs data until RD returns to HIGH
     TFT_RD = 0;
      BD_as_input(); // Set arduino pins as input
       port_TFT = TFT_DataPort;       // Salva data port
        TFT_RD = 1;
         BD_as_output(); // Re-Set arduino pins as output
          return port_TFT;
 }
// *****************************************************************************
// Data Port come ingresso
// *****************************************************************************
 void BD_as_input(void) {
//
    TFT_DataPort_Direction = 0xFF;    // Input
 }
// *****************************************************************************
// Data Port come uscita
// *****************************************************************************
 void BD_as_output(void) {
 //
     TFT_DataPort_Direction = 0x00;  // Output
 }
// *****************************************************************************
// Inizializza TFT
// *****************************************************************************
 void LCD_init(void) {
//
     TFT_RST = 1;
      Delay_msec(10);
       TFT_RST = 0;
        Delay_msec(20);
         TFT_RST = 1;
          Delay_msec(20);
// CS HIGH, WR HIGH, RD HIGH, CS LOW
    TFT_CS = 1;
     TFT_WR = 1;
      TFT_RD = 1;
       TFT_CS = 0;
//
      LCD_command_write(0xF7); // Pump ratio control
       LCD_data_write(0x20); //
//
        LCD_command_write(0x3A); // COLMOD: Pixel Format Set
         LCD_data_write(0x55);
//
          LCD_command_write(0x36); // Memory Access Control
  // MY  - Row Address Order         (bit7)
  // MX  - Column Address Order      (bit6)
  // MV  - Row / Column Exchange     (bit5)
  // ML  - Vertical Refresh Order    (bit4)
  // BGR - RGB-BGR Order             (bit3)
  // MH  - Horizontal Refresh ORDER  (bit2)

// 0x58: Orizzontale contrario (OK);
// 0x88: Orizz. normale (OK)
// 0x28: Verticale
// 0xE8: Verticale contrario
          LCD_data_write(0x88);         // 0B00001000   0b10000000(attuale)
//
           LCD_command_write(0x11); // Sleep OUT
            LCD_command_write(0x29); // Display ON
//
             Delay_msec(50);
 }
// *****************************************************************************
// Imposta un punto sullo schermo
// *****************************************************************************
 void TFT_set_display_window(unsigned int x1, unsigned int y1,
                             unsigned int x2, unsigned int y2) {
//
    LCD_command_write(0x2a);           // 0x2A Column
    LCD_data_write(y1 >> 8);
    LCD_data_write(y1);
    LCD_data_write(y2 >> 8);
    LCD_data_write(y2);
//
     LCD_command_write(0x2b);             // Page Address Set
     LCD_data_write(x1 >> 8);
     LCD_data_write(x1);
     LCD_data_write(x2 >> 8);
     LCD_data_write(x2);
//
      LCD_command_write(0x2c);            // Memory Write
 }
// *****************************************************************************
// Disegna rettangolo
// *****************************************************************************
 void LCD_rect(int col,int row, int width, int height, int color) {
  char chigh, clow;
  unsigned int i,j;
 //
   TFT_set_display_window(col, row, (col+width-1), (row+height-1));  // (x1, y1, x2, y2)

  chigh = color >> 8;
  clow = color;

  for(i=0; i<width; i++)
    for(j=0; j<height; j++)
    {
      LCD_data_write(chigh);
      LCD_data_write(clow);
    }
 }
// *****************************************************************************
// Pulisce lo schermo
// *****************************************************************************
 void LCD_clear(char color) {
  unsigned int x, y;
//
   TFT_set_display_window(0, 0, 319, 239); // (x1, y1, x2, y2)
    TFT_RS = 1;
     TFT_DataPort = color;
//
      x = 38400;                 // 240*320/2
       for(y=0;y<x;y++) {
         TFT_WR = 0;
         TFT_WR = 1;
         TFT_WR = 0;
         TFT_WR = 1;

          TFT_WR = 0;
          TFT_WR = 1;
          TFT_WR = 0;
          TFT_WR = 1;
       }
 }
// *****************************************************************************
// Scrivi intero sullo schemo
// *****************************************************************************
 void Display_integer(int n) {
  char txt[7];
  char i;
//
      IntToStr(n, txt);
       for(i=0; i<6; i++) {
         Display_char(txt[i]);
       }
 }
// *****************************************************************************
// Scrivi stringa sullo schermo
// *****************************************************************************
 void Display_string(char *str) {
  char i = 0;
//
     while (str[i] != '\0') {
       Display_char(str[i]);
        i++;
     }
 }
// *****************************************************************************
// Tabella ASCII
// *****************************************************************************
  const char ASCII [] = {
    0x00, 0x00, 0x00, 0x00, 0x00, // 20
    0x00, 0x00, 0x5f, 0x00, 0x00, // 21 !
    0x00, 0x07, 0x00, 0x07, 0x00, // 22 "
    0x14, 0x7f, 0x14, 0x7f, 0x14, // 23 #
    0x24, 0x2a, 0x7f, 0x2a, 0x12, // 24 $
    0x23, 0x13, 0x08, 0x64, 0x62, // 25 %
    0x36, 0x49, 0x55, 0x22, 0x50, // 26 &
    0x00, 0x00, 0x07, 0x05, 0x07, // 27 '
    0x00, 0x1c, 0x22, 0x41, 0x00, // 28 (
    0x00, 0x41, 0x22, 0x1c, 0x00, // 29 )
    0x14, 0x08, 0x3e, 0x08, 0x14, // 2a *
    0x08, 0x08, 0x3e, 0x08, 0x08, // 2b +
    0x00, 0x50, 0x30, 0x00, 0x00, // 2c ,
    0x08, 0x08, 0x08, 0x08, 0x08, // 2d -
    0x00, 0x60, 0x60, 0x00, 0x00, // 2e .
    0x20, 0x10, 0x08, 0x04, 0x02, // 2f /
    0x3e, 0x51, 0x49, 0x45, 0x3e, // 30 0
    0x00, 0x42, 0x7f, 0x40, 0x00, // 31 1
    0x42, 0x61, 0x51, 0x49, 0x46, // 32 2
    0x21, 0x41, 0x45, 0x4b, 0x31, // 33 3
    0x18, 0x14, 0x12, 0x7f, 0x10, // 34 4
    0x27, 0x45, 0x45, 0x45, 0x39, // 35 5
    0x3c, 0x4a, 0x49, 0x49, 0x30, // 36 6
    0x01, 0x71, 0x09, 0x05, 0x03, // 37 7
    0x36, 0x49, 0x49, 0x49, 0x36, // 38 8
    0x06, 0x49, 0x49, 0x29, 0x1e, // 39 9
    0x00, 0x36, 0x36, 0x00, 0x00, // 3a :
    0x00, 0x56, 0x36, 0x00, 0x00, // 3b ;
    0x08, 0x14, 0x22, 0x41, 0x00, // 3c <
    0x14, 0x14, 0x14, 0x14, 0x14, // 3d =
    0x00, 0x41, 0x22, 0x14, 0x08, // 3e >
    0x02, 0x01, 0x51, 0x09, 0x06, // 3f ?
    0x32, 0x49, 0x79, 0x41, 0x3e, // 40 @
    0x7e, 0x11, 0x11, 0x11, 0x7e, // 41 A
    0x7f, 0x49, 0x49, 0x49, 0x36, // 42 B
    0x3e, 0x41, 0x41, 0x41, 0x22, // 43 C
    0x7f, 0x41, 0x41, 0x22, 0x1c, // 44 D
    0x7f, 0x49, 0x49, 0x49, 0x41, // 45 E
    0x7f, 0x09, 0x09, 0x09, 0x01, // 46 F
    0x3e, 0x41, 0x49, 0x49, 0x7a, // 47 G
    0x7f, 0x08, 0x08, 0x08, 0x7f, // 48 H
    0x00, 0x41, 0x7f, 0x41, 0x00, // 49 I
    0x20, 0x40, 0x41, 0x3f, 0x01, // 4a J
    0x7f, 0x08, 0x14, 0x22, 0x41, // 4b K
    0x7f, 0x40, 0x40, 0x40, 0x40, // 4c L
    0x7f, 0x02, 0x0c, 0x02, 0x7f, // 4d M
    0x7f, 0x04, 0x08, 0x10, 0x7f, // 4e N
    0x3e, 0x41, 0x41, 0x41, 0x3e, // 4f O
    0x7f, 0x09, 0x09, 0x09, 0x06, // 50 P
    0x3e, 0x41, 0x51, 0x21, 0x5e, // 51 Q
    0x7f, 0x09, 0x19, 0x29, 0x46, // 52 R
    0x46, 0x49, 0x49, 0x49, 0x31, // 53 S
    0x01, 0x01, 0x7f, 0x01, 0x01, // 54 T
    0x3f, 0x40, 0x40, 0x40, 0x3f, // 55 U
    0x1f, 0x20, 0x40, 0x20, 0x1f, // 56 V
    0x3f, 0x40, 0x38, 0x40, 0x3f, // 57 W
    0x63, 0x14, 0x08, 0x14, 0x63, // 58 X
    0x07, 0x08, 0x70, 0x08, 0x07, // 59 Y
    0x61, 0x51, 0x49, 0x45, 0x43, // 5a Z
    0x00, 0x7f, 0x41, 0x41, 0x00, // 5b [
    0x02, 0x04, 0x08, 0x10, 0x20, // 5c Y
    0x00, 0x41, 0x41, 0x7f, 0x00, // 5d ]
    0x04, 0x02, 0x01, 0x02, 0x04, // 5e ^
    0x40, 0x40, 0x40, 0x40, 0x40, // 5f _
    0x00, 0x01, 0x02, 0x04, 0x00, // 60 `
    0x20, 0x54, 0x54, 0x54, 0x78, // 61 a
    0x7f, 0x48, 0x44, 0x44, 0x38, // 62 b
    0x38, 0x44, 0x44, 0x44, 0x20, // 63 c
    0x38, 0x44, 0x44, 0x48, 0x7f, // 64 d
    0x38, 0x54, 0x54, 0x54, 0x18, // 65 e
    0x08, 0x7e, 0x09, 0x01, 0x02, // 66 f
    0x0c, 0x52, 0x52, 0x52, 0x3e, // 67 g
    0x7f, 0x08, 0x04, 0x04, 0x78, // 68 h
    0x00, 0x44, 0x7d, 0x40, 0x00, // 69 i
    0x20, 0x40, 0x44, 0x3d, 0x00, // 6a j
    0x7f, 0x10, 0x28, 0x44, 0x00, // 6b k
    0x00, 0x41, 0x7f, 0x40, 0x00, // 6c l
    0x7c, 0x04, 0x18, 0x04, 0x78, // 6d m
    0x7c, 0x08, 0x04, 0x04, 0x78, // 6e n
    0x38, 0x44, 0x44, 0x44, 0x38, // 6f o
    0x7c, 0x14, 0x14, 0x14, 0x08, // 70 p
    0x08, 0x14, 0x14, 0x18, 0x7c, // 71 q
    0x7c, 0x08, 0x04, 0x04, 0x08, // 72 r
    0x48, 0x54, 0x54, 0x54, 0x20, // 73 s
    0x04, 0x3f, 0x44, 0x40, 0x20, // 74 t
    0x3c, 0x40, 0x40, 0x20, 0x7c, // 75 u
    0x1c, 0x20, 0x40, 0x20, 0x1c, // 76 v
    0x3c, 0x40, 0x30, 0x40, 0x3c, // 77 w
    0x44, 0x28, 0x10, 0x28, 0x44, // 78 x
    0x0c, 0x50, 0x50, 0x50, 0x3c, // 79 y
    0x44, 0x64, 0x54, 0x4c, 0x44, // 7a z
    0x00, 0x08, 0x36, 0x41, 0x00, // 7b {
    0x00, 0x00, 0x7f, 0x00, 0x00, // 7c |
    0x00, 0x41, 0x36, 0x08, 0x00, // 7d }
    0x10, 0x08, 0x08, 0x10, 0x08, // 7e ?
    0x00, 0x06, 0x09, 0x09, 0x06  // 7f ?
  };
// *****************************************************************************
// Scrivi carattere sullo schermo
// *****************************************************************************
 void Display_char(char znak) {
//
  unsigned int buf;
  char size = F_SIZE;       // 3
  int color = F_COLOR;
  int bcolor = B_COLOR;
  char bchigh;
  char bclow;
  char fchigh;
  char fclow;
  char index, nbit, i, j;
  char col, mask;
//
   if( (P_COL + (size*6)) > 319) {
     P_COL = 0;
      P_ROW += size*(8+1);
   }
    TFT_set_display_window(P_COL, P_ROW, (P_COL+(size*6)), ((P_ROW+size*8)-1)); // (x1, y1, x2, y2)
//
     bchigh = bcolor >> 8;
      bclow = bcolor;
       fchigh = color >> 8;
        fclow = color;
//
      for (index = 0; index <5; index++) {    // index = da 0 a 4
        buf = ((znak - 0x20)*5)+(index);
         col = ASCII[buf];
//
          for ( i=0; i<size; i++){                // size = 3
            mask = 0B00000001;
             for (nbit = 0; nbit < 8; nbit++) {     // nbit = 8
               if (col & mask) {                    // col.bit = 1
                 for (j=0; j<size; j++){
                   LCD_data_write(fchigh);          // Colore carattere
                    LCD_data_write(fclow);
                 }
               }
                 else {                              // col.bit = 0
                   for (j=0; j<size; j++){
                     LCD_data_write(bchigh);         // colore back
                      LCD_data_write(bclow);
                   }
                 }
                   mask = mask<<1;
             } // for nbit
          } // for size
      } //for index
//
       P_COL += size*6;
 }
// *****************************************************************************
// Cancella carattere sullo schermo
// *****************************************************************************
 void Display_clear_char(char n) {
// delete n chars
  char size = F_SIZE;
  int bcolor = B_COLOR;
  char bchigh;
  char bclow;
  int i, cyc;
//
    TFT_set_display_window(P_COL, P_ROW, (P_COL+(size*6*n)), ((P_ROW+size*8)-1)); // (x1, y1, x2, y2)
//
     bchigh = bcolor >> 8;
      bclow = bcolor;
       cyc = size*8 * size*6*n;
        for (i=0; i<cyc; i++) {
          LCD_data_write(bchigh);
           LCD_data_write(bclow);
        }
 }
// *****************************************************************************
// Disegna *.BMP
// *****************************************************************************
 void Draw_BMP(unsigned int x_pos1, unsigned int y_pos1, unsigned int x_pos2,
              unsigned int y_pos2, const unsigned int *bitmap) {
//
  unsigned long size = 0x00000000;
  unsigned long index = 0x00000000;
  unsigned int buf1;
// --- Inverti valori X se X2  maggiore di X1
     if(x_pos1 > x_pos2) {
       buf1 = x_pos1;
        x_pos1 = x_pos2;
         x_pos2 = buf1;
     }
// --- Inverti valori Y se Y2  maggiore di Y1
     if(y_pos1 > y_pos2) {
       buf1 = y_pos1;
        y_pos1 = y_pos2;
         y_pos2 = buf1;
     }
//
      size = (y_pos2 - y_pos1);           // Calcola il numero di pixel necessari
       size *= (x_pos2 - x_pos1);
//
        TFT_set_display_window(x_pos1, y_pos1, (x_pos2 - 1), (y_pos2 - 1));
//
         for(index = 0; index < size; index++) {
           LCD_data_write(bitmap[index]>>8);
            LCD_data_write(bitmap[index]);
         }
 }
// *****************************************************************************
// Calibrazione dal touch
// *****************************************************************************
 void Calibration_touch(void) {
  char buf = 1;
//
    if (cnt_16 <= time_1) {
      if (col > 80 && row > 80) {
        cnt_16 ++;
         Delay_msec(5);
          sw_value = 10;
      }
        else  {
          cnt_16 = 0;
           sw_value = 10;
            return;
        }
//
          if (cnt_16 <= time_1) {     // 1000 = 5 sec.
            return;
          }
            if (cnt_16 > time_1) {
              sw_value = 1;
            }
    }    //   LED ^= 1;
      B_COLOR = 0x0C0C;     // Azzurro
//
      switch (sw_value) {
         case 1: LCD_clear(0x0C);
                 if (col < 20 && row < 20) {
                   sw_value = 2; break;
                 }
                   else break;

         case 2: LCD_clear(0x0C);
                 F_COLOR = BLUE;      // Blue!
                 P_COL=10; P_ROW=110;
                 Display_string("Premi alto a Sx");
                  if (col > 80 && row > 80) {
                    row_0 = row;
                     col_0 = col;
                      sw_value = 3;
                       break;
                  }
                    else break;

         case 3: if (col < 20 && row < 20) {
                   sw_value = 4; break;
                 }
                   else break;

         case 4: LCD_clear(0x0C);
                 F_COLOR = RED;      // Rosso!
                 P_COL=10; P_ROW=110;
                 Display_string("Premi alto a Dx");
                  if (col > 80 && row > 80) {

                     col_320 = col;
                      sw_value = 5;
                       break;
                  }
                    else break;

         case 5: if (col < 20 && row < 20) {
                   sw_value = 6; break;
                 }
                   else break;

         case 6: LCD_clear(0x0C);
                 F_COLOR = YELLOW;      // Giallo!
                 P_COL=10; P_ROW=110;
                 Display_string("Premi basso a Sx");
                  if (col > 80 && row > 80) {
                    row_240 = row;

                      sw_value = 7;
                       break;
                  }
                    else break;

         default: break;
      }


 }
// *****************************************************************************
// Leggi il touch
// *****************************************************************************
 char ReadTouch(void) {
//
  int rows, cols, abs;
  char touch, wait_touch, valid;
  unsigned long row1, col1;
  wait_touch=1;
  valid=0;

    while (wait_touch) {
// --- row
      TFT_WR_Direction = 1;                  //  Y1, INPUT
       TFT_DataPort_Direction.B7 = 1;  //b1       Y2, INPUT_PULLUP
        TFT_RS_Direction = 0;             // X1   OUTPUT
         TFT_DataPort_Direction.B6 = 0;    //b0   X2   OUTPUT
          TFT_RS = 0;                       //  X1    LOW
           LATC.B6 = 0;                      // X2     LOW
//
      touch = !PORTA.B1;        //B1  (Y1)               //!digitalRead(Y1); // 0 - touched
       if (touch) {
         TFT_RS = 1;                       //  X1    HIGH
          LATC.B6 = 0;                       // X2    HIGH
           Delay_msec(1);
            row = ADC_Read(1);     //    ADC A1 (TFT_WR) Y1
             Delay_msec(4);
    ///////////////  if (abs(analogRead(Y1)-row)>3) { return 0;}  ///////////////  ADC A2
    //  if (abs(ADC_Read(1)-row)>3) return 0;

    //  Delay_msec(3);
    ///////////////////  if (abs(analogRead(Y1)-row)>3) { return 0;}   /////////////////////// ADC A2
      // if (abs(ADC_Read(1)-row)>3) return 0;

      //if (analogRead(Y1)!=row) { return 0;}
// --- col
         TFT_RS_Direction = 1;                // X1  INPUT
          TFT_DataPort_Direction.B6 = 1;  //b0    X2  INPUT_PULLUP
           TFT_WR_Direction = 0;         // Y1       OUTPUT         ///////////////////////////////////
            TFT_DataPort_Direction.B7 = 0;  //b1   Y2   OUTPUT
             TFT_WR = 1;     // Y1        LOW                  //////////////////////////////////////
              LATC.B7 = 0;      // Y2    HIGH
               Delay_msec(1);
                col = ADC_Read(0);     //    ADC A0 (TFT_RS) X1
                 Delay_msec(4);
    ////////////////////  if (abs(analogRead(X1)-col)>3) { return 0;}  ////////////////////////// ADC  A1
    //   if (abs(ADC_Read(1)-col)>3) return 0;
    //  Delay_msec(3);
    ////////////////////////  if (abs(analogRead(X1)-col)>3) { return 0;}  ////////////////////// ADC A1
    //   if (abs(ADC_Read(1)-col)>3) return 0;
      //if (analogRead(X1)!=col) { return 0;}

      //////digitalWrite(Y1, LOW);  // Y variant A
      //digitalWrite(Y2, LOW);  // Y variant B
         LATC.B7 =0;
      //delay(5);
          touch = !PORTA.B0;    //b0                   //!digitalRead(X1); // 0 - dotyk

         if (col > 100 && row > 100) {
           rows = ROW_L - ROW_F;           // 515 (641 - 126)
            cols = COL_L - COL_F;            // 571 (685 - 114)
            //  row1=(row-ROW_F)/rows*240;  // row1 = (analog read - 126) / 515 * 240  (515 * 240 = 123600)
            //  col1=(col-COL_F)/cols*320;  // col1 = (analog read - 114) / 571 * 320  (571 * 320 = 182720)
             row1 = (24000 / rows) * (row-ROW_F) / 100;
              col1 = (32000 / cols) * (col-COL_F) / 100;
               T_ROW = row1;
                T_COL = col1;
                 valid=1;
         }

          wait_touch=0;
       }
    }
// Re-Set A2 A3 8 9 for ILI9341
         BD_as_output();                   // Data_portC = out
          TFT_RS_Direction = 0; // OUT
           TFT_WR_Direction = 0;  // OUT
//
       Calibration_touch();
        if (sw_value == 7) {
          sw_value = 0;
           cnt_16 = 0;
            page_1();
             EEPROM_Write(0x00, col_0 >> 8);       // Col_0
              EEPROM_Write(0x01, col_0);
               EEPROM_Write(0x02, col_320 >> 8);  // col_320
                EEPROM_Write(0x03, col_320);
                 EEPROM_Write(0x04, row_0 >> 8);    // row_0
                  EEPROM_Write(0x05, row_0);
                   EEPROM_Write(0x06, row_240 >> 8);  // row_240
                    EEPROM_Write(0x07, row_240);

        }
// To find out values for calibration F_ROW, L_ROW, F_COL, F_COL
// --- ATTENZIONE! ELIMINARE QUANDO NON SERVONO PIU'
  // /*

         B_COLOR=0x0C0C;
          F_SIZE=2;
           P_COL=240;            // 230
            P_ROW=80;            // 200
             Display_integer(row);
              P_COL=240;           //  280
               P_ROW=100;           //  200
                Display_integer(col);


         F_SIZE=2;
          P_COL=240;           //  230
           P_ROW=130;           //  220
            Display_clear_char(3);
             Display_integer(T_ROW);
              P_COL=240;           //  280
               P_ROW=150;           //  220
                Display_clear_char(3);
                 Display_integer(T_COL);
                  B_COLOR=GREEN;
                  


          F_SIZE=3;
  // */
// Draw a point where touched
        //  LCD_rect(T_COL-1,T_ROW-1, 20, 20,RED);

           return valid;
 }