/*
 * Project name:
                        TFT, 2,4 inc, ILI9341
 * Copyright:

 * Revision History:
                    - 30/10/2018: initial release;
                    - 1/11/2018:  FUNZIONA. Alcune funzioni da testare.
                    - 2/11/2018:  Per funzionare in touch, spostare dei fili
                                  sulla porta A per usare ADC.
                    -8/11/2018:   Impostato funzione disegna bmp. Il disegno va modificato
                                  con il programma "bitmaptoarray.exe", directory:
                                  "BITMAP ARRAY CONVERTER".
                    -8/11/2018:   Calibrazione del touch.
                                  Tenere premuto un punto dello schermo per circa 15 secondi
                                  ed entrare in modalit calibrazione, seguendo le istruzioni
                                  a schermo.

 * Description:    Prime prove con display 2,4 inc per Arduino

 * Test configuration:
     MCU:             PIC18F4520

     Dev.Board:      bread board

     Oscillator:      Interno, 8MHz * PLL = 32MHz MHz
     Modules:
     SW:              mikroC PRO for PIC

 * NOTES:
                      - L'alimentazione a 3,3V non  necessaria per il funzionamento del display
                        (forse serve per SD o il touch).
                      - No, il touch in questo display  autonomo e va usato con ADC del PIC
                        per leggere il punto toccato.
                      - Il display funziona a 3,3V. E' completo di riduttore di tensione.
                        Se il PIC lavora a 3,3V, il display va alimentato direttamente a 3,3V, 
                        assieme al PIC.
                        Per le prove, il PIC  alimentato a 5V e il TFT a 5V (ridotta dal alim.
                        interno a 3,3V). Funziona comunque perfettamente.

*/
//
 #include "bmp.c"
 #include "bmp_2.c"
 #include "TFT_2_4_Lib.c"
//
 #define LED (PORTD.F2)              // LED
//
 char page;
//
// *****************************************************************************
//
// *****************************************************************************
void Delay_msec (unsigned int count_delay){
      for (count_delay; count_delay > 0; count_delay --){
         Delay_1ms () ;
        }
  }
// *****************************************************************************
// Setup
// *****************************************************************************
 void setup() {
//
// Set pins 1-8 as output
     BD_as_output();
//
      LCD_init();
       LCD_clear(0x0C);
//
         D_COL=200; // where to display number from keypad
          D_ROW=5;
 }
// *****************************************************************************
// Disegna pagina 1
//  K_LABEL[] = "7   8   9    4  5  6    1  2  3       0   <";
//  K_ROW[]  = {125,125,125,  65,65,65,  5, 5, 5,    185,185};
//  K_COL[]  = {10, 70, 130,  10,70,130, 10,70,130,  70, 130};
// *****************************************************************************
 void Page_1() {
  char i;
//
     page = 1;
//
      LCD_clear(0x0C);
//
       B_COLOR = GREEN;
        F_COLOR = BLACK;
         F_SIZE=4;
// draw a keypad
        for (i=0; i<11; i++) {
          P_COL=K_COL[i];
           P_ROW=K_ROW[i];
            LCD_rect(P_COL,P_ROW, 50, 50, GREEN);
             P_COL=K_COL[i]+8;
              P_ROW=K_ROW[i]+4;
               Display_char(K_LABEL[i]);
        }
// --- Pulsante per cambio pagina
      F_SIZE=3;
        B_COLOR = YELLOW;
        F_COLOR = BLACK;
          P_COL = 200;
           P_ROW = 185;
            LCD_rect(P_COL, P_ROW, 110, 50, YELLOW);
             P_COL=200+2;
              P_ROW=185+10;
               Display_string("Page 2");
//
 }
// *****************************************************************************
// Disegna pagina 1
// *****************************************************************************
 void Page_2() {
  char i;
//
     page = 2;
//
      LCD_clear(0x0C);
//
      B_COLOR = 0x0c0c;
       F_COLOR = RED;
        F_SIZE=6;
         P_COL=20;
          P_ROW=80;
           Display_string("Page 2");
// --- Pulsante per cambio pagina
       F_SIZE=3;
        B_COLOR = YELLOW;
        F_COLOR = BLACK;
          P_COL = 200;
           P_ROW = 185;
            LCD_rect(P_COL, P_ROW, 110, 50, YELLOW);
             P_COL=200+2;
              P_ROW=185+10;
               Display_string("Page 1");
//
 }
// *****************************************************************************
// Main
// *****************************************************************************
 void main() {
  char touch;
  int i ;
  int row, col;
//
   ADCON1 = 0b00001111;
   CMCON = 0b00000111;
//
   OSCTUNE = 0b01000000;     // PLL ON: 8*4 = 32MHz
   OSCCON = 0b01110010;     // 8MHz
//
   TRISD = 0b00000000;
   TRISC = 0b00000000;
   TRISA = 0b00000000;
//
      ADC_Init();

       setup ();
    //    Page_1();
// --- Riprendi i valori di calibrazione touch screen
       col_0 = Eeprom_Read(0x00);
       col_0 = col_0 << 8;
       col_0 |= Eeprom_Read(0x01);
        col_320 = Eeprom_Read(0x02);
        col_320 = col_320 << 8;
        col_320 |= Eeprom_Read(0x03);
         row_0 = Eeprom_Read(0x04);
         row_0 = row_0 << 8;
         row_0 |= Eeprom_Read(0x05);
          row_240 = Eeprom_Read(0x06);
          row_240 = row_240 << 8;
          row_240 |= Eeprom_Read(0x07);
        
        sw_value = 0;
         cnt_16 = 0;
         
       LCD_clear(0x0C);
       B_COLOR = GREEN;
        F_COLOR = BLACK;
        
        LCD_rect(220,80, 50, 30, RED);

        P_COL=0;
       P_ROW=10;
       F_COLOR = BLACK;         // Blue!
        B_COLOR = 0x0C0C;
        F_SIZE=1;
       Display_string("JUMBO elettronica");

       P_COL=0;
       P_ROW=25;
       F_COLOR = RED;         // Blue!
        B_COLOR = 0x0C0C;
        F_SIZE=2;
       // Display_string("jumbo");
       Display_integer(12345);

      F_COLOR = BLUE;      // Rosso!
       P_COL=0;
        P_ROW=50;
        F_SIZE=3;
         Display_string("JUMBO elettronica");
         
       F_COLOR = YELLOW;      // Rosso!
       P_COL=0;
        P_ROW=90;
        F_SIZE=5;
         Display_string("JUMBO");
         
         F_COLOR = WHITE;      // Rosso!
       P_COL=0;
        P_ROW=150;
        F_SIZE=8;
         Display_string("JUMBO");
         
// --- Test disegna bmp
     //  Draw_BMP(0, 0, 133, 100, image);  //  OK
      //  Draw_BMP(0, 0, 64, 128, image3);  //  OK
     //   Draw_BMP(250, 112, 314, 240, image3);  //  OK

      Delay_msec(100);
       F_SIZE=4;
       Page_1();

//
      while (1) {

          LED = 1;
           Delay_msec(50);
          LED = 0;
           Delay_msec(50);

        touch = ReadTouch();
// --- Pagina 1
         if(touch && page == 1) {
            for (i=0; i<11; i++) {
               if ( T_COL >K_COL[i] && T_COL <K_COL[i]+50 && T_ROW>K_ROW[i] && T_ROW<K_ROW[i]+50 ) {
                 P_COL=K_COL[i];
                 P_ROW=K_ROW[i];
                 LCD_rect(P_COL,P_ROW, 50, 50, RED);
                 P_COL=K_COL[i]+8;
                 P_ROW=K_ROW[i]+4;
                 B_COLOR = BLACK;
                  F_SIZE=3;
                  Display_char(K_LABEL[i]);
                   if (K_LABEL[i]=='<') {
                     if (D_COL>10){
                       D_COL-=F_SIZE*6;
                        P_COL=D_COL;
                         P_ROW=D_ROW;
                          B_COLOR=0x0C0C;
                           Display_clear_char(1);
                     }
                   }
                     else if( (D_COL + (F_SIZE*6)) < 320 ) {
                       P_COL=D_COL;
                        P_ROW=D_ROW;
                         B_COLOR=0x0C0C;
                          Display_char(K_LABEL[i]);
                           D_COL=P_COL;
                            D_ROW=P_ROW;
                     }
                       Delay_us(100);
                        P_COL = K_COL[i];
                         P_ROW = K_ROW[i];
                          LCD_rect(P_COL,P_ROW, 50, 50, GREEN);
                           P_COL=K_COL[i]+8;
                            P_ROW=K_ROW[i]+4;
                             B_COLOR=GREEN;
                              F_COLOR = BLACK;
                             F_SIZE=4;
                              Display_char(K_LABEL[i]);
               }
            }
              if (T_COL > 200 && T_COL < 310 && T_ROW > 185 && T_ROW < 235) {
                T_COL = 0;
                 T_ROW = 0;
                  Page_2();
              }
         }
// --- Pagina 2
           if(touch && page == 2) {
             if (T_COL > 200 && T_COL < 310 && T_ROW > 185 && T_ROW < 235) {
               T_COL = 0;
                T_ROW = 0;
                 Page_1();
             }
           }
      }
//
 }
/*
















*/